class Interface
{
public:

	Interface(char *datapath_dir);
	virtual ~Interface(void);

    TTF_Font *ButtonsFont;

    int ButtonSelected;
    int ArrowSetSelected;
    int ArrowSelected;

    #define NumberOfGUIs     31
    struct GUI
    {
        GLuint OGL_Texture;
        int OnScreenIndex;
        GLfloat ScreenX;
        GLfloat ScreenY;
        GLfloat ScaleX;
        GLfloat ScaleY;
        GLfloat RotationDegree;
        GLfloat Transparency;
        GLfloat RedHue;
        GLfloat GreenHue;
        GLfloat BlueHue;
        bool Smooth;
        bool FlipX;
        bool FlipY;
        GLfloat Width;
        GLfloat Height;
        GLfloat OffsetX;
        GLfloat OffsetY;
        GLfloat CenterX;
        GLfloat CenterY;
        int AnimationTimer;
    } GUIs[NumberOfGUIs];

    bool CreateAllGUIAndInitialize(bool initialize);

    void CreateButton(int imageIndex, int screenIndex, GLfloat screenX, GLfloat screenY);
    void DisplayAllButtonsOntoScreenBuffer(void);
    void ProcessAllButtonsOnScreen(void);
    void DestroyAllButtons(void);

    void CreateArrowSet(int leftArrowScreenIndex, int rightArrowScreenIndex, GLfloat positionY);
    void DisplayAllArrowSetsOntoScreenBuffer(void);
    void ProcessAllArrowSetsOnScreen(void);
    void DestroyAllArrowSets(void);

    void UnloadGUIFromMemory(void);

private:
    char datapath[256];
};
