class Logic
{
public:

    #define OriginalMode                0
    #define TimeAttack30Mode            1
    #define TimeAttack60Mode            2
    #define TimeAttack120Mode           3
    #define TwentyLineChallengeMode     4
    #define CrisisMode                  5
    Uint8 GameMode;

    Uint8 MaxRotationArray[8];

    Uint8 SelectedBackground;
    Uint8 SelectedMusicTrack;

	Uint8 PieceData[8][5][17];

	Uint8 Player;
    #define NumberOfPlayers     3
    struct PlayData
    {
        int Playfield[15][26];
        int PlayfieldBackup[15][26];

        Uint8 Piece;
        Sint8 PieceMovementDelay;
        Uint8 PieceRotation;
        Uint8 PiecePlayfieldX;
        Uint8 PiecePlayfieldY;
        Uint8 NextPiece;

        #define GameOver					-1
        #define NewPieceDropping			0
        #define PieceFalling				1
        #define FlashingCompletedLines		2
        #define ClearingCompletedLines		3
        #define ClearingPlayfield           4
        Sint16 PlayerStatus;

        float PlayersPlayfieldScreenX;
        float PlayersPlayfieldScreenY;
        int PieceDropTimer;
        int TimeToDropPiece;
        bool PieceRotated1;
        bool PieceRotated2;

        int OldTrappedHoles;
        int NewTrappedHoles[15][5];

        int OldPlayfieldHeight;
        int NewPlayfieldHeight[15][5];

        int FallenPieceHeight[15][5];

        int OldNumberOfOneBlockCavernHoles;
        int NewNumberOfOneBlockCavernHoles[15][5];

        int MoveCompletesLines[15][5];

        int BestMoveX;
        int BestRotation;
        bool MovedToBestMove;
        bool BestMoveCalculated;

        bool UPActionTaken;
        Uint8 RotateDirection;

        int PlayerInput;

        Uint8 FlashCompletedLinesTimer;
        Uint8 ClearCompletedLinesTimer;

    	Uint8 AttackLines[10][12];

        Uint8 TwentyLineCounter;

        int SkipAFrameForCPUPieceDrop;
        int CPUFrame;

        Uint32 Score;
        Uint32 DropBonus;
        Uint16 Level;
        Uint16 Lines;

    } PlayerData[NumberOfPlayers];

    bool CrisisModeOnePlayerLeftPlayfieldCleared;

    int TotalCPUPlayerLines;
    int NumberofCPUGames;

    bool GameDisplayChanged;

    bool DisplayNextPiece;
    bool DisplayDropShadow;
    #define None            0
    #define Fall            1
    #define Rotate          2
    Uint8 PressingUPAction;

    bool PlayersCanJoin;

    Uint32 TimeAttackTimer;

    Uint16 ThinkRussianTimer;

    Uint16 CrisisModeTimer;

    bool Crisis7BGMPlayed;
    bool CrisisWon;

    bool GameWasJustPlayed;

	bool PAUSEgame;

    Uint8 TileSet;

	Logic(void);
	virtual ~Logic(void);

	void InitializePieceData(void);
	void ClearPlayfieldsWithCollisionDetection(void);
	Uint8 GetRandomPiece(void);

    #define CollisionNotTrue            0
    #define CollisionWithPlayfield      1
	int PieceCollision(void);
	int PieceCollisionDown(void);

	#define Current		0
	#define Next		1
	#define DropShadow	2
	void AddPieceToPlayfieldMemory(int TempOrCurrentOrNextOrDropShadow);
	void DeletePieceFromPlayfieldMemory(int CurrentOrDropShadow);

    void SetupNewPiece(void);

	void CheckForCompletedLines(void);

	void MovePieceDown(bool Force);
    void MovePieceDownFast(void);
	bool RotatePieceCounterClockwise(void);
	bool RotatePieceClockwise(void);
	void MovePieceLeft(void);
	void MovePieceRight(void);

	void SetupForNewGame(void);

	void DisplayTetriScreenOntoScreenBuffer(void);

	void FlashCompletedLines(void);
	void ClearCompletedLines(void);

	void AddAnAttackLineToEnemiesPlayfield(void);

    bool AddAnIncompleteLineToPlayfieldCrisisMode(void);

	void RunTetriGameEngine(void);

    bool CrisisModeClearPlayfield(void);

    void ComputeComputerPlayerMove(void);
};
