#include <stdint.h>

#include <iostream>
#include <string.h>
#include <sstream>
#include <string>

#include "runtime.h"

Runtime::Runtime(const int argc, char** argv)
{
	width = 640;
	height = 480;

	int i;

	for(i = 0; i < argc; i++)
	{
		if(strncmp(argv[i], "--width", sizeof("--width")) == 0)
		{
			i++;
			if(i < argc)
			{
				if(StringToInt(argv[i], width) == false)
				{
					cout << __FILE__ << ":" << __LINE__ << " error: failed to read --width argument" << endl;
				}
			}
			else
			{
				cout << __FILE__ << ":" << __LINE__ << " error: missing --width argument" << endl;
			}
		}
		else if(strncmp(argv[i], "--height", sizeof("--height")) == 0)
		{
			i++;
			if(i < argc)
			{
				if(StringToInt(argv[i], height) == false)
				{
					cout << __FILE__ << ":" << __LINE__ << " error: failed to read --height argument" << endl;
				}
			}
			else
			{
				cout << __FILE__ << ":" << __LINE__ << " error: missing --height argument" << endl;
			}
		}
	}
}

uint32_t Runtime::getWidth()
{
	return width;
}

uint32_t Runtime::getHeight()
{
	return height;
}

bool Runtime::StringToInt(const string &s, uint32_t &i)
{
	istringstream myStream(s);

	if (myStream>>i)
		return true;
	else
		return false;
}

