class Visuals
{
public:

	Visuals(char *datapath_dir);
	virtual ~Visuals(void);

    SDL_Surface *Screen;
    int ScreenWidth;
    int ScreenHeight;

    bool ColorIsRGBA;
    Uint32 R_Mask, G_Mask, B_Mask, A_Mask;

    #define NumberOfSprites     400
    struct Sprite
    {
        GLuint OGL_Texture;
        GLfloat ScreenX;
        GLfloat ScreenY;
        GLfloat ScaleX;
        GLfloat ScaleY;
        GLfloat RotationDegree;
        GLfloat Transparency;
        GLfloat redHue;
        GLfloat greenHue;
        GLfloat blueHue;
        bool Smooth;
        bool FlipX;
        bool FlipY;
        int Width;
        int Height;
        int CenterX;
        int CenterY;
        int AnimationTimer;
    } Sprites[NumberOfSprites];

    #define JustifyLeft             0
    #define JustifyCenter           1
    #define JustifyRight            2
    #define JustifyCenterOnPoint    3

    #define NumberOfFonts           6
    TTF_Font *FontDefault[NumberOfFonts];
    char VariableText[64];

    #define NumberOfLoadedTexts     100
    struct LoadedText
    {
        GLuint OGL_Texture;
        GLfloat ScreenX;
        GLfloat ScreenY;
        GLfloat Transparency;
        GLfloat redHue;
        GLfloat greenHue;
        GLfloat blueHue;
        GLfloat TextWidth;
        GLfloat TextHeight;
        GLfloat Width;
        GLfloat Height;
    } LoadedTexts[NumberOfLoadedTexts];

    int TotalNumberOfLoadedTexts;

    bool SetupGameWindow(int width, int height);
    bool SetupGameWindowAgain(void);

    bool LoadSpritesIntoMemoryAndInitialize(void);
    void UnloadSpritesFromMemory(void);
    void DrawSpriteOntoScreenBuffer(Uint16 index);

    bool LoadFontsIntoMemory(void);
    void UnloadFontsFromMemory(void);
    int NextPowerOfTwo(int x);
    void DrawTextOntoScreenBuffer(const char *textToDisplay, TTF_Font *font, GLfloat posX, GLfloat posY
                                  , Uint8 XJustification, Uint8 textRed, Uint8 textGreen, Uint8 textBlue
                                  , Uint8 outlineRed, Uint8 outlineGreen, Uint8 outlineBlue);

    bool LoadAllTextsIntoMemory(void);
    void UnloadAllTextsFromMemory(void);
    void DrawLoadedTextOntoScreenBuffer(Uint16 index, GLfloat posX, GLfloat posY);

    void ClearScreenBufferWithColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
    void DisplayScreenBufferOntoDisplay(void);
    
private:
    char datapath[256];
};
